
/////////////////////////////////////////////////////////////////
//	CN[ht@C
//////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

/////////////////////////////////////////////////////////////////
// DD_DD_AddBlendBlt16֐
// Z
/////////////////////////////////////////////////////////////////
HRESULT DD_AddBlendBlt16(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	WORD			*lpSurfaceDst;		//]T[tFCX̃|C^
	WORD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	WORD			colorKey;			//J[L[
	DWORD			RDst,GDst,BDst;		//]RGB
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	DWORD			RBitMask,GBitMask,BBitMask;	//RGB̃}XNl	
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( WORD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( WORD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( WORD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( WORD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ( WORD )ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//e}XNl̎擾
	RBitMask = ddsdSrc.ddpfPixelFormat.dwRBitMask;
	GBitMask = ddsdSrc.ddpfPixelFormat.dwGBitMask;
	BBitMask = ddsdSrc.ddpfPixelFormat.dwBBitMask;

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			if( !( lpSurfaceSrc[ j ] == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//]̎wp[Ze[WRGB߂
				RDst = ( lpSurfaceDst[ j ] & RBitMask );
				GDst = ( lpSurfaceDst[ j ] & GBitMask );
				BDst = ( lpSurfaceDst[ j ] & BBitMask );
				RSrc = ( ( lpSurfaceSrc[ j ] & RBitMask ) >> 3 ) & RBitMask;
				GSrc = ( ( lpSurfaceSrc[ j ] & GBitMask ) >> 3 ) & GBitMask;
				BSrc = ( ( lpSurfaceSrc[ j ] & BBitMask ) >> 3 ) & BBitMask;
				if( RDst + RSrc > RBitMask )	RDst = RBitMask;
				else							RDst = RDst + RSrc;
				if( GDst + GSrc > GBitMask )	GDst = GBitMask;
				else							GDst = GDst + GSrc;
				if( BDst + BSrc > BBitMask )	BDst = BBitMask;
				else							BDst = BDst + BSrc;

				//Fɂ܂Ƃ߂
				lpSurfaceDst[ j ] = ( WORD )( RDst | GDst | BDst );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_DD_AddBlendBlt24֐
// Z
/////////////////////////////////////////////////////////////////
HRESULT DD_AddBlendBlt24(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBTRIPLE		*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBTRIPLE		*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBTRIPLE* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBTRIPLE* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBTRIPLE );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBTRIPLE );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];
			srcColorKey &= 0xffffff;
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				RSrc = ( lpSurfaceSrc[ j ].rgbtRed )	>> 3;
				GSrc = ( lpSurfaceSrc[ j ].rgbtGreen )	>> 3;
				BSrc = ( lpSurfaceSrc[ j ].rgbtBlue )	>> 3;
				//]̎wp[Ze[WRGB߂
				if( lpSurfaceDst[ j ].rgbtRed + RSrc > 0xff )	lpSurfaceDst[ j ].rgbtRed = 0xff;
				else						lpSurfaceDst[ j ].rgbtRed = ( BYTE )( lpSurfaceDst[ j ].rgbtRed + RSrc );
				if( lpSurfaceDst[ j ].rgbtGreen + GSrc > 0xff )	lpSurfaceDst[ j ].rgbtGreen = 0xff;
				else						lpSurfaceDst[ j ].rgbtGreen = ( BYTE )( lpSurfaceDst[ j ].rgbtGreen + GSrc );
				if( lpSurfaceDst[ j ].rgbtBlue + BSrc > 0xff )	lpSurfaceDst[ j ].rgbtBlue = 0xff;
				else						lpSurfaceDst[ j ].rgbtBlue = ( BYTE )( lpSurfaceDst[ j ].rgbtBlue + BSrc );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_DD_AddBlendBlt32֐
// Z
/////////////////////////////////////////////////////////////////
HRESULT DD_AddBlendBlt32(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBQUAD			*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBQUAD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBQUAD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBQUAD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBQUAD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBQUAD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];			
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				RSrc = ( lpSurfaceSrc[ j ].rgbRed )	>> 3;
				GSrc = ( lpSurfaceSrc[ j ].rgbGreen )	>> 3;
				BSrc = ( lpSurfaceSrc[ j ].rgbBlue )	>> 3;
				//]̎wp[Ze[WRGB߂
				if( lpSurfaceDst[ j ].rgbRed + RSrc > 0xff )	lpSurfaceDst[ j ].rgbRed = 0xff;
				else						lpSurfaceDst[ j ].rgbRed = ( BYTE )( lpSurfaceDst[ j ].rgbRed + RSrc );
				if( lpSurfaceDst[ j ].rgbGreen + GSrc > 0xff )	lpSurfaceDst[ j ].rgbGreen = 0xff;
				else						lpSurfaceDst[ j ].rgbGreen = ( BYTE )( lpSurfaceDst[ j ].rgbGreen + GSrc );
				if( lpSurfaceDst[ j ].rgbBlue + BSrc > 0xff )	lpSurfaceDst[ j ].rgbBlue = 0xff;
				else						lpSurfaceDst[ j ].rgbBlue = ( BYTE )( lpSurfaceDst[ j ].rgbBlue + BSrc );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}