
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

/////////////////////////////////////////////////////////////////
// DD_AlphaBlt16֐
// 16bit
//////////////////////////////////////////////////////////////////
HRESULT DD_AlphaBlt16(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	double				 alpha,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	WORD			*lpSurfaceDst;		//]T[tFCX̃|C^
	WORD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	WORD			colorKey;			//J[L[
	DWORD			RDst,GDst,BDst;		//]RGB
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	DWORD			RBitMask,GBitMask,BBitMask;	//RGB̃}XNl
	DWORD			DstAlpha,SrcAlpha;	//]Ãp[Ze[W
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( WORD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( WORD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( WORD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( WORD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ( WORD )ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//e}XNl̎擾
	RBitMask = ddsdSrc.ddpfPixelFormat.dwRBitMask;
	GBitMask = ddsdSrc.ddpfPixelFormat.dwGBitMask;
	BBitMask = ddsdSrc.ddpfPixelFormat.dwBBitMask;

	//]Ãp[Ze[W߂
	DstAlpha = ( DWORD )( ( 1.0 - alpha ) * 0x100 );
	SrcAlpha = ( DWORD )( alpha * 0x100 );

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			if( !( lpSurfaceSrc[ j ] == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//]̎wp[Ze[WRGB߂
				RDst = ( ( ( lpSurfaceDst[ j ] & RBitMask ) * DstAlpha ) >> 8 ) & RBitMask;
				GDst = ( ( ( lpSurfaceDst[ j ] & GBitMask ) * DstAlpha ) >> 8 ) & GBitMask;
				BDst = ( ( ( lpSurfaceDst[ j ] & BBitMask ) * DstAlpha ) >> 8 ) & BBitMask;
				//]̎wp[Ze[WRGB߂
				RSrc = ( ( ( lpSurfaceSrc[ j ] & RBitMask ) * SrcAlpha ) >> 8 ) & RBitMask;
				GSrc = ( ( ( lpSurfaceSrc[ j ] & GBitMask ) * SrcAlpha ) >> 8 ) & GBitMask;
				BSrc = ( ( ( lpSurfaceSrc[ j ] & BBitMask ) * SrcAlpha ) >> 8 ) & BBitMask;
				//Fɂ܂Ƃ߂
				lpSurfaceDst[ j ] = ( WORD )( ( RDst + RSrc ) | ( GDst + GSrc ) | ( BDst + BSrc ) );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_AlphaBlt24֐
// 24bit
/////////////////////////////////////////////////////////////////
HRESULT DD_AlphaBlt24(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	double				 alpha,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBTRIPLE		*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBTRIPLE		*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;		
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	DWORD			DstAlpha,SrcAlpha;	//]Ãp[Ze[W
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBTRIPLE* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBTRIPLE* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBTRIPLE );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBTRIPLE );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//]Ãp[Ze[W߂
	DstAlpha = ( DWORD )( ( 1.0 - alpha ) * 0x100 );
	SrcAlpha = ( DWORD )( alpha * 0x100 );

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];
			srcColorKey &= 0xffffff;
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//]̎wp[Ze[WRGB߂
				RSrc = ( lpSurfaceSrc[ j ].rgbtRed		* SrcAlpha) >> 8;
				GSrc = ( lpSurfaceSrc[ j ].rgbtGreen	* SrcAlpha) >> 8;
				BSrc = ( lpSurfaceSrc[ j ].rgbtBlue		* SrcAlpha) >> 8;
				//]̎wp[Ze[WRGB߁A]Ƃ܂Ƃ߂
				lpSurfaceDst[ j ].rgbtRed	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbtRed		* DstAlpha) >> 8) + RSrc);
				lpSurfaceDst[ j ].rgbtGreen	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbtGreen		* DstAlpha) >> 8) + GSrc);
				lpSurfaceDst[ j ].rgbtBlue	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbtBlue		* DstAlpha) >> 8) + BSrc);
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_AlphaBlt32֐
// 32bit
/////////////////////////////////////////////////////////////////
HRESULT DD_AlphaBlt32(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	double				 alpha,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBQUAD			*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBQUAD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	DWORD			RSrc,GSrc,BSrc;		//]RGB
	DWORD			DstAlpha,SrcAlpha;	//]Ãp[Ze[W
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBQUAD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBQUAD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBQUAD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBQUAD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//]Ãp[Ze[W߂
	DstAlpha = ( DWORD )( ( 1.0 - alpha ) * 0x100 );
	SrcAlpha = ( DWORD )( alpha * 0x100 );

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//]̎wp[Ze[WRGB߂
				RSrc = ( lpSurfaceSrc[ j ].rgbRed		* SrcAlpha) >> 8;
				GSrc = ( lpSurfaceSrc[ j ].rgbGreen		* SrcAlpha) >> 8;
				BSrc = ( lpSurfaceSrc[ j ].rgbBlue		* SrcAlpha) >> 8;
				//]̎wp[Ze[WRGB߁A]Ƃ܂Ƃ߂
				lpSurfaceDst[ j ].rgbRed	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbRed		* DstAlpha ) >> 8 ) + RSrc );
				lpSurfaceDst[ j ].rgbGreen	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbGreen		* DstAlpha ) >> 8 ) + GSrc );
				lpSurfaceDst[ j ].rgbBlue	= ( BYTE )( ( ( lpSurfaceDst[ j ].rgbBlue		* DstAlpha ) >> 8 ) + BSrc );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}