
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

/////////////////////////////////////////////////////////////////
// DD_DD_MaskBlt16֐
// }XNJ[
//////////////////////////////////////////////////////////////////
HRESULT DD_MaskBlt16(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,	
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	WORD			*lpSurfaceDst;		//]T[tFCX̃|C^
	WORD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	WORD			colorKey;			//J[L[
	DWORD			RDst = 0 ,GDst = 0,BDst = 0;//]RGB
	DWORD			RBitMask,GBitMask,BBitMask;	//RGB̃}XNl	
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( WORD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( WORD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( WORD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( WORD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ( WORD )ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//e}XNl̎擾
	RBitMask = ddsdSrc.ddpfPixelFormat.dwRBitMask;
	GBitMask = ddsdSrc.ddpfPixelFormat.dwGBitMask;
	BBitMask = ddsdSrc.ddpfPixelFormat.dwBBitMask;

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			if( !( lpSurfaceSrc[ j ] == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//
				if( USE_R & dwFlags )
					RDst = ( lpSurfaceSrc[ j ] & RBitMask );
				if( USE_G & dwFlags )
					GDst = ( lpSurfaceSrc[ j ] & GBitMask );
				if( USE_B & dwFlags )
					BDst = ( lpSurfaceSrc[ j ] & BBitMask );
				//Fɂ܂Ƃ߂
				lpSurfaceDst[ j ] = ( WORD )( RDst | GDst | BDst );
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_DD_MaskBlt24֐
// }XNJ[
/////////////////////////////////////////////////////////////////
HRESULT DD_MaskBlt24(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,	
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBTRIPLE		*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBTRIPLE		*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBTRIPLE* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBTRIPLE* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBTRIPLE );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBTRIPLE );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];
			srcColorKey &= 0xffffff;
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//
				lpSurfaceDst[ j ].rgbtRed  = 0;
				lpSurfaceDst[ j ].rgbtGreen = 0;
				lpSurfaceDst[ j ].rgbtBlue = 0;
				if( USE_R & dwFlags )
					lpSurfaceDst[ j ].rgbtRed = lpSurfaceSrc[ j ].rgbtRed;
				if( USE_G & dwFlags )
					lpSurfaceDst[ j ].rgbtGreen = lpSurfaceSrc[ j ].rgbtGreen;
				if( USE_B & dwFlags )
					lpSurfaceDst[ j ].rgbtBlue = lpSurfaceSrc[ j ].rgbtBlue;
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_DD_MaskBlt32֐
// }XNJ[
/////////////////////////////////////////////////////////////////
HRESULT DD_MaskBlt32(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,	
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBQUAD			*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBQUAD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//					
	int				i,j;
	HRESULT			ret;				//G[`FbN
	
	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBQUAD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBQUAD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBQUAD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBQUAD );

	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0 ; i < nHeight ; i++ ){
		for( j = 0 ; j < nWidth ; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];			
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//
				lpSurfaceDst[ j ].rgbRed  = 0;
				lpSurfaceDst[ j ].rgbGreen = 0;
				lpSurfaceDst[ j ].rgbBlue = 0;
				if( USE_R & dwFlags )
					lpSurfaceDst[ j ].rgbRed = lpSurfaceSrc[ j ].rgbRed;
				if( USE_G & dwFlags )
					lpSurfaceDst[ j ].rgbGreen = lpSurfaceSrc[ j ].rgbGreen;
				if( USE_B & dwFlags )
					lpSurfaceDst[ j ].rgbBlue = lpSurfaceSrc[ j ].rgbBlue;
			}
		}
		lpSurfaceDst += lPitchDst;
		lpSurfaceSrc += lPitchSrc;
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}