
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

/////////////////////////////////////////////////////////////////
// DD_MosaicBlt16֐
// UCN
//////////////////////////////////////////////////////////////////
HRESULT DD_MosaicBlt16(
	LPDIRECTDRAWSURFACE7 lpDDS,
	RECT				 rcDst,
	int					 size )
{
	DDSURFACEDESC2	ddsd;				//T[tFCX	
	LONG			pitch;				//sb`
	WORD			*lpSurface;			//]T[tFCX̃|C^
	WORD			dat;
	int				nWidth,nHeight;		//摜̕ƍ
	int				i,j;
	int				x,y;
	static int		mx = 0,my = 0,wait;
	HRESULT			ret;				//G[`FbN

	//]̈̃TCY߂
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	
	//UCÑTCYs̏ꍇ͏I
	if( size <= 1 || nWidth % size != 0 || nHeight % size != 0){
		return DD_OK;
	}
	if( rcDst.left < 0 || SCREEN_WIDTH < rcDst.right || rcDst.top < 0 || SCREEN_HEIGHT < rcDst.bottom ){
		return DD_OK;
	}

	ddsd.dwSize = sizeof( ddsd );
	//]̈̃bN
	ret = lpDDS->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;

	//]A]T[tFCX̃|C^擾
	lpSurface = ( WORD* )ddsd.lpSurface;
		
	pitch = ddsd.lPitch / sizeof( WORD );	//[hTCY
	
	//]̈܂Ń|C^炷
	lpSurface += ( rcDst.top * pitch + rcDst.left );	

	//_^C~O
	wait++;
	if( !( wait & 7 ) ){
		mx = rand() % ( nWidth / ( nWidth / size ) );
		my = rand() % ( nHeight / ( nHeight / size ) );
	}
	
	//摜]
	for( i = 0 ; i < nHeight; i+=size ){
		for( j = 0 ; j < nWidth; j+=size ){
			dat = lpSurface[ ( i + my ) * pitch + ( j + mx ) ];
			for( y = i ; y < i + ( nHeight / ( nHeight / size ) ) ; y++ ){
				for( x = j ; x < j + ( nWidth / ( nWidth / size ) ) ; x++ ){
					lpSurface[ y * pitch + x ] = dat;
				}
			}
		}
	}

	//]ẼAbN
	lpDDS->Unlock( NULL );

	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_MosaicBlt24֐
// UCN
/////////////////////////////////////////////////////////////////
HRESULT DD_MosaicBlt24(
	LPDIRECTDRAWSURFACE7 lpDDS,
	RECT				 rcDst,
	int					 size )
{
	DDSURFACEDESC2	ddsd;				//T[tFCX	
	LONG			pitch;				//sb`
	RGBTRIPLE		*lpSurface;			//]T[tFCX̃|C^
	RGBTRIPLE		dat;
	int				nWidth,nHeight;		//摜̕ƍ
	int				i,j;
	int				x,y;
	static int		mx = 0,my = 0,wait;
	HRESULT			ret;				//G[`FbN

	//]̈̃TCY߂
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	
	//UCÑTCYs̏ꍇ͏I
	if( size <= 1 || nWidth % size != 0 || nHeight % size != 0){
		return DD_OK;
	}
	if( rcDst.left < 0 || SCREEN_WIDTH < rcDst.right || rcDst.top < 0 || SCREEN_HEIGHT < rcDst.bottom ){
		return DD_OK;
	}

	ddsd.dwSize = sizeof( ddsd );
	//]̈̃bN
	ret = lpDDS->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;

	//]A]T[tFCX̃|C^擾
	lpSurface = ( RGBTRIPLE* )ddsd.lpSurface;
		
	pitch = ddsd.lPitch / sizeof( RGBTRIPLE );	//RGBTRIPLETCY
	
	//]̈܂Ń|C^炷
	lpSurface += ( rcDst.top * pitch + rcDst.left );	

	//_^C~O
	wait++;
	if( !( wait & 7 ) ){
		mx = rand() % ( nWidth / ( nWidth / size ) );
		my = rand() % ( nHeight / ( nHeight / size ) );
	}
	
	//摜]
	for( i = 0 ; i < nHeight; i+=size ){
		for( j = 0 ; j < nWidth; j+=size ){
			dat = lpSurface[ ( i + my ) * pitch + ( j + mx ) ];
			for( y = i ; y < i + ( nHeight / ( nHeight / size ) ) ; y++ ){
				for( x = j ; x < j + ( nWidth / ( nWidth / size ) ) ; x++ ){
					lpSurface[ y * pitch + x ] = dat;
				}
			}
		}
	}

	//]ẼAbN
	lpDDS->Unlock( NULL );

	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_MosaicBlt32֐
// UCN
/////////////////////////////////////////////////////////////////
HRESULT DD_MosaicBlt32(
	LPDIRECTDRAWSURFACE7 lpDDS,
	RECT				 rcDst,
	int					 size )
{
	DDSURFACEDESC2	ddsd;				//T[tFCX	
	LONG			pitch;				//sb`
	RGBQUAD			*lpSurface;			//]T[tFCX̃|C^
	RGBQUAD			dat;
	int				nWidth,nHeight;		//摜̕ƍ
	int				i,j;
	int				x,y;
	static int		mx = 0,my = 0,wait;
	HRESULT			ret;				//G[`FbN

	//]̈̃TCY߂
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	
	//UCÑTCYs̏ꍇ͏I
	if( size <= 1 || nWidth % size != 0 || nHeight % size != 0){
		return DD_OK;
	}
	if( rcDst.left < 0 || SCREEN_WIDTH < rcDst.right || rcDst.top < 0 || SCREEN_HEIGHT < rcDst.bottom ){
		return DD_OK;
	}

	ddsd.dwSize = sizeof( ddsd );
	//]̈̃bN
	ret = lpDDS->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;

	//]A]T[tFCX̃|C^擾
	lpSurface = ( RGBQUAD* )ddsd.lpSurface;
		
	pitch = ddsd.lPitch / sizeof( RGBQUAD );	//RGBQUADTCY
	
	//]̈܂Ń|C^炷
	lpSurface += ( rcDst.top * pitch + rcDst.left );	

	//_^C~O
	wait++;
	if( !( wait & 7 ) ){
		mx = rand() % ( nWidth / ( nWidth / size ) );
		my = rand() % ( nHeight / ( nHeight / size ) );
	}
	
	//摜]
	for( i = 0 ; i < nHeight; i+=size ){
		for( j = 0 ; j < nWidth; j+=size ){
			dat = lpSurface[ ( i + my ) * pitch + ( j + mx ) ];
			for( y = i ; y < i + ( nHeight / ( nHeight / size ) ) ; y++ ){
				for( x = j ; x < j + ( nWidth / ( nWidth / size ) ) ; x++ ){
					lpSurface[ y * pitch + x ] = dat;
				}
			}
		}
	}

	//]ẼAbN
	lpDDS->Unlock( NULL );

	return DD_OK;
}