
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

/////////////////////////////////////////////////////////////////
// DD_RotateBlt16֐
// 摜]
//////////////////////////////////////////////////////////////////
HRESULT DD_RotateBlt16(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	int					 angle,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	WORD			*lpSurfaceDst;		//]T[tFCX̃|C^
	WORD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	WORD			colorKey;			//J[L[
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//						
	int				s,c;				//]sinlAcosl
	int				Fx,Fy;				//]sinlAcosl
	int				x1,x2,y1,y2;		//
	POINT			center;				//SW
	HRESULT			ret;				//G[`FbN

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( WORD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( WORD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( WORD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( WORD );
	
	//J[L[̎擾
	colorKey = ( WORD )ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;
	
	//TCY擾
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	//]̒S
	center.x = rcDst.left + ( nWidth >> 1 );
	center.y = rcDst.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceDst += ( center.y * lPitchDst + center.x);
	//]̒S
	center.x = rcSrc.left + ( nWidth >> 1 );
	center.y = rcSrc.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceSrc += ( center.y * lPitchSrc + center.x);
	//wpxsin cosl擾iŒ菬_̃e[u苁߂j
	s = sin_table[ angle ];
	c = cos_table[ angle ];
	//͈͂߂
	Fx = ( cos_table[ 45 ] * nWidth ) >> 16;
	Fy = ( sin_table[ 45 ] * nHeight ) >> 16;

	//摜
	for( y1 = -Fy ; y1 < Fy ; y1++ ){
		//]悪͈͊OȂ珈Ȃ
		if( ( y1 + rcDst.top + ( nHeight >> 1 ) < 0 ) || ( y1 + rcDst.bottom - ( nHeight >> 1 ) ) >= (int)ddsdDst.dwHeight )	continue;
		for( x1 = -Fx ; x1 < Fx ; x1++ ){
			//]悪͈͊OȂ珈Ȃ
			if(  ( x1 + rcDst.left + ( nWidth >> 1 ) < 0 ) || ( x1 + rcDst.right - ( nWidth >> 1 ) ) >= (int)ddsdDst.dwWidth )	continue;
			//]̈ʒu𒲂ׂ
			x2 = ( x1 * c - y1 * s ) >> 16;
			y2 = ( x1 * s + y1 * c ) >> 16;
			//]͈͊OȂ珈Ȃ
			if( x2 < -( nWidth >> 1 ) || x2 >= ( nWidth >> 1 ) )	continue;
			if( y2 < -( nHeight >> 1 ) || y2 >= ( nHeight >> 1 ) )	continue;
			//]̊GFǂݎ
			if( !( ( lpSurfaceSrc[ y2 * lPitchSrc + x2 ] == colorKey ) && ( dwFlags & USE_COLORKEY ) ) ){
				lpSurfaceDst[ y1 * lPitchDst + x1 ] = lpSurfaceSrc[ y2 * lPitchSrc + x2 ];
			}
		}
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_RotateBlt24֐
// 摜]
/////////////////////////////////////////////////////////////////
HRESULT DD_RotateBlt24(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	int					 angle,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBTRIPLE		*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBTRIPLE		*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//						
	int				s,c;				//]sinlAcosl
	int				Fx,Fy;				//]sinlAcosl
	int				x1,x2,y1,y2;		//
	POINT			center;				//SW
	HRESULT			ret;				//G[`FbN

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBTRIPLE* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBTRIPLE* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBTRIPLE );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBTRIPLE );
	
	//J[L[̎擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;
	
	//TCY擾
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	//]̒S
	center.x = rcDst.left + ( nWidth >> 1 );
	center.y = rcDst.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceDst += ( center.y * lPitchDst + center.x);
	//]̒S
	center.x = rcSrc.left + ( nWidth >> 1 );
	center.y = rcSrc.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceSrc += ( center.y * lPitchSrc + center.x);
	//wpxsin cosl擾iŒ菬_̃e[u苁߂j
	s = sin_table[ angle ];
	c = cos_table[ angle ];
	//͈͂߂
	Fx = ( cos_table[ 45 ] * nWidth ) >> 16;
	Fy = ( sin_table[ 45 ] * nHeight ) >> 16;

	//摜
	for( y1 = -Fy ; y1 < Fy ; y1++ ){
		//]悪͈͊OȂ珈Ȃ
		if( ( y1 + rcDst.top + ( nHeight >> 1 ) < 0 ) || ( y1 + rcDst.bottom - ( nHeight >> 1 ) ) >= (int)ddsdDst.dwHeight )	continue;
		for( x1 = -Fx ; x1 < Fx ; x1++ ){
			//]悪͈͊OȂ珈Ȃ
			if(  ( x1 + rcDst.left + ( nWidth >> 1 ) < 0 ) || ( x1 + rcDst.right - ( nWidth >> 1 ) ) >= (int)ddsdDst.dwWidth )	continue;
			//]̈ʒu𒲂ׂ
			x2 = ( x1 * c - y1 * s ) >> 16;
			y2 = ( x1 * s + y1 * c ) >> 16;
			//]͈͊OȂ珈Ȃ
			if( x2 < -( nWidth >> 1 ) || x2 >= ( nWidth >> 1 ) )	continue;
			if( y2 < -( nHeight >> 1 ) || y2 >= ( nHeight >> 1 ) )	continue;
			//]̊GFǂݎ
			//srcColorKey = *(DWORD*)( lpSurfaceSrc + x2 + y2 * lPitchSrc );
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ y2 * lPitchSrc + x2 ];
			srcColorKey &= 0xffffff;
			if( !( ( srcColorKey == colorKey ) && ( dwFlags & USE_COLORKEY ) ) ){				
				lpSurfaceDst[ y1 * lPitchDst + x1 ] = lpSurfaceSrc[ y2 * lPitchSrc + x2 ];
			}
		}
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}


/////////////////////////////////////////////////////////////////
// DD_RotateBlt32֐
// 摜]
/////////////////////////////////////////////////////////////////
HRESULT DD_RotateBlt32(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	int					 angle,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;			//]T[tFCX
	DDSURFACEDESC2	ddsdSrc;			//]T[tFCX
	RGBQUAD			*lpSurfaceDst;		//]T[tFCX̃|C^
	RGBQUAD			*lpSurfaceSrc;		//]T[tFCX̃|C^
	DWORD			colorKey;			//J[L[
	DWORD			srcColorKey;
	LONG			lPitchDst;			//]T[tFCX̃sb`
	LONG			lPitchSrc;			//]T[tFCX̃sb`
	int				nWidth;				//]̈̃TCY@
	int				nHeight;			//						
	int				s,c;				//]sinlAcosl
	int				Fx,Fy;				//]sinlAcosl
	int				x1,x2,y1,y2;		//
	POINT			center;				//SW
	HRESULT			ret;				//G[`FbN

	//\̎gp
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )	return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
		lpDDSDst->Unlock( NULL );
		return ret;
	}

	//]ÃT[tFCX̃|C^擾
	lpSurfaceDst = ( RGBQUAD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBQUAD* )ddsdSrc.lpSurface;

	//]Ãsb`̎擾
	lPitchDst = ddsdDst.lPitch / sizeof( RGBQUAD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBQUAD );
	
	//J[L[̎擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;
	
	//TCY擾
	nWidth  = rcDst.right - rcDst.left;
	nHeight = rcDst.bottom - rcDst.top;
	//]̒S
	center.x = rcDst.left + ( nWidth >> 1 );
	center.y = rcDst.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceDst += ( center.y * lPitchDst + center.x);
	//]̒S
	center.x = rcSrc.left + ( nWidth >> 1 );
	center.y = rcSrc.top + ( nHeight >> 1 );
	//|C^ړ
	lpSurfaceSrc += ( center.y * lPitchSrc + center.x);
	//wpxsin cosl擾iŒ菬_̃e[u苁߂j
	s = sin_table[ angle ];
	c = cos_table[ angle ];
	//͈͂߂
	Fx = ( cos_table[ 45 ] * nWidth ) >> 16;
	Fy = ( sin_table[ 45 ] * nHeight ) >> 16;

	//摜
	for( y1 = -Fy ; y1 < Fy ; y1++ ){
		//]悪͈͊OȂ珈Ȃ
		if( ( y1 + rcDst.top + ( nHeight >> 1 ) < 0 ) || ( y1 + rcDst.bottom - ( nHeight >> 1 ) ) >= (int)ddsdDst.dwHeight )	continue;
		for( x1 = -Fx ; x1 < Fx ; x1++ ){
			//]悪͈͊OȂ珈Ȃ
			if(  ( x1 + rcDst.left + ( nWidth >> 1 ) < 0 ) || ( x1 + rcDst.right - ( nWidth >> 1 ) ) >= (int)ddsdDst.dwWidth )	continue;
			//]̈ʒu𒲂ׂ
			x2 = ( x1 * c - y1 * s ) >> 16;
			y2 = ( x1 * s + y1 * c ) >> 16;
			//]͈͊OȂ珈Ȃ
			if( x2 < -( nWidth >> 1 ) || x2 >= ( nWidth >> 1 ) )	continue;
			if( y2 < -( nHeight >> 1 ) || y2 >= ( nHeight >> 1 ) )	continue;
			//]̊GFǂݎ
			//srcColorKey = *(DWORD*)( lpSurfaceSrc + x2 + y2 * lPitchSrc );
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ y2 * lPitchSrc + x2 ];
			if( !( ( srcColorKey == colorKey ) && ( dwFlags & USE_COLORKEY ) ) ){				
				lpSurfaceDst[ y1 * lPitchDst + x1 ] = lpSurfaceSrc[ y2 * lPitchSrc + x2 ];
			}
		}
	}

	//]AT[tFCX̃AbN
	lpDDSDst->Unlock( NULL );
	lpDDSSrc->Unlock( NULL );
	
	//
	return DD_OK;
}
